#include<cstdio>
#include<iostream>
#include<algorithm>
#include<cstring>
#include<ctime>
using namespace std;

const int dx[8] = {1, -1, 0, 0, 1, -1, 1, -1};
const int dy[8] = {0, 0, 1, -1, 1, -1, -1, 1};

char data[110][110];

void generate(int x, int y, int N, int M, int d, int tot) {
	data[x][y] = '#'; 
	if (rand()%600 < tot) return;
	
	for (int k = 0; k < 8; ++k) {
		int nx = x + dx[k], ny = y + dy[k];
		
		if (nx < 0 || nx >= N || ny < 0 || ny >= M) continue;
		if (data[nx][ny] == '#') continue;
		
		if (k != d && rand()%100 >= 5) continue;
		if (k == d && rand()%100 >= 98) continue;
		generate(nx, ny, N, M, k, tot+1);
	}

}

int main() {
	freopen("save.in", "w", stdout);
	
	srand(time(NULL));
	
	int E = 10;
	for(int T = 0; T < 50; ++T) {
		int N = 100, M = 100;
		int V = rand()%10;
		printf("%d %d %d\n", N, M, V);
		
		// generate ground
		memset(data, 0, sizeof data);
		for (int i = 0; i < N; ++i)
			for(int j = 0; j < M; ++j) {
				data[i][j] = '.';
				if (rand()%100 < E)
					data[i][j] = 'E';
			}
		
		// generate barrier
		generate(rand()%N, 0, N, M, 2, 0);
		generate(rand()%N, M-1, N, M, 3, 0);
		generate(0, rand()%M, N, M, 0, 0);
		generate(N-1, rand()%M, N, M, 1, 0);
		
		// generate S & T
		int n = N/2, m = M/2;
		int Sx = rand()%n, Sy = rand()%m;
		data[Sx][Sy] = 'S';
		int Tx = rand()%n+n, Ty = rand()%m+m;
		data[Tx][Ty] = 'T';
		
		for (int i = 0; i < N; ++i)
			printf("%s\n", data[i]);
	}
	printf("0 0\n");
	return 0;
}
