#include<cstdio>
#include<algorithm>
#include<cstring>
#include<queue>
using namespace std;

const int dx[4] = {1, -1, 0, 0};
const int dy[4] = {0, 0, 1, -1};

struct Tdata {
	int x, y, e, d;
	Tdata() {}
	Tdata(int _x, int _y, int _e, int _d) {
		x = _x; y = _y; e = _e; d = _d;
	}
};

bool vis[110][110][20][4];
int step[110][110][20][4];
int n, m, V, Sx, Sy, Tx, Ty;
char data[110][110];
deque<Tdata> q; 

int solve() {
	queue<Tdata> q;
	memset(vis, 0, sizeof vis);
	memset(step, 30, sizeof step);
	int inf = step[0][0][0][0], ans = inf;
		
	for (int k = 0; k < 4; ++k) {
		q.push(Tdata(Sx, Sy, V, k));
		vis[Sx][Sy][V][k] = 1;
		step[Sx][Sy][V][k] = 0;
	}
	
	while(!q.empty()) {
		Tdata now = q.front(); q.pop();
		int x = now.x, y = now.y, e = now.e, d = now.d;
		int t = step[x][y][e][d];
		
		// drop
		for (int k = 0; k <= e; ++k) {
			if (step[x][y][e-k][d] > t) {
				step[x][y][e-k][d] = t;
				if (!vis[x][y][e-k][d]) {
					vis[x][y][e-k][d] = 1;
					q.push(Tdata(x, y, e-k, d));
				}
			}
		}
		
		// jump
		if (data[x][y] == 'E') {
			int nx = x + e * dx[d], ny = y + e * dy[d];
			nx = min(max(nx, 0), n-1);
			ny = min(max(ny, 0), m-1);
			if (data[nx][ny] != '#') {
				if (step[nx][ny][e][d] > t) {
					step[nx][ny][e][d] = t;
					if (!vis[nx][ny][e][d]) {
						vis[nx][ny][e][d] = 1;
						q.push(Tdata(nx, ny, e, d));
					}
				}
			}
		}
		
		// walk
		for (int k = 0; k < 4; ++k) {
			int nx = x + dx[k], ny = y + dy[k];
			if (nx<0 || nx>=n || ny<0 || ny>=m || data[nx][ny] == '#') continue;
			if (step[nx][ny][e][k] > t+1) {
				step[nx][ny][e][k] = t+1;
				if(!vis[nx][ny][e][k]) {
					vis[nx][ny][e][k] = 1;
					q.push(Tdata(nx, ny, e, k));
				}
			}
		}
		
		vis[x][y][e][d] = 0;
	}
	
	for (int e = 0; e <= V; ++e)
		for (int k = 0; k < 4; ++k)
			ans = min(ans, step[Tx][Ty][e][k]);
			
	return ans == inf ? -1 : ans;
}

int main() {
	freopen("save.in", "r", stdin);
	freopen("save.ans", "w", stdout);
	int cas = 0;
	while(~scanf("%d%d%d", &n, &m, &V)) {
		if (n == 0 && m == 0 && V == 0) break;
		for (int i = 0; i < n; ++i) {
			scanf("%s", data[i]);
			for (int j = 0; j < m; ++j) {
				if (data[i][j] == 'S') Sx = i, Sy = j;
				if (data[i][j] == 'T') Tx = i, Ty = j;
			}
		}
		
		int ans = solve();
		
		printf("Case #%d: %d\n", ++cas, ans);
	}
	return 0;
}
